#!/usr/bin/env php
<?php
set_include_path(get_include_path() . PATH_SEPARATOR . '/usr/local/mgr5/include/php');
define('__MODULE__', 'fraudhosting');
require_once 'fraudhosting_func.php';

Info("FraudHosting plugin started");

// Define config files
$moduleConfig = parseConfig('etc/fh_module.conf');
$dbConfig = parseConfig('etc/billmgr.conf.d/db.conf');

// Get env params
$param_func = getenv('PARAM_func');
$param_sok = getenv('PARAM_sok');
$param_email = getenv('PARAM_email');
$param_realname = getenv('PARAM_realname');
$param_authlevel = getenv('AUTH_LEVEL');

// Stop, if non matched params
//if ($param_authlevel !== '29') { die("Auth level not admin"); }
if ($param_func !== 'register') { die("Requested function is wrong"); }
if (empty($param_realname)) { die("Realname is empty"); }
if (empty($param_email)) { die("Email is empty"); }
if (empty($param_sok) || $param_sok !== 'ok') { die("sok=ok not found"); }

Info("Auth level: " . $param_authlevel);
Info("Realname: " . $param_realname);
Info("Email: " . $param_email);

$AutoCheck = trim($moduleConfig['AutoCheck']);
Info("Autocheck clients after registration is: " . $AutoCheck);
if ($AutoCheck !== 'on') { die("AutoCheck disabled"); }

try {
    $pdo = connectToDatabase($dbConfig['DBHost'], $dbConfig['DBUser'], $dbConfig['DBPassword'], $dbConfig['DBName']);
} catch (PDOException $e) {
    if ($dbConfig['DBHost'] === 'localhost') {
        try {
            $pdo = connectToDatabase('127.0.0.1', $dbConfig['DBUser'], $dbConfig['DBPassword'], $dbConfig['DBName']);
        } catch (PDOException $e) {
            Error("Database connection failed: " . $e->getMessage());
            die("Unable to connect to the database.");
        }
    } else {
        Error("Database connection failed: " . $e->getMessage());
        die("Unable to connect to the database.");
    }
}

// Trying to find new registered client into database
$attempts = 1;
$max_attempts = 10;
$interval = 1;
while ($attempts <= $max_attempts) {
    Info("Attempt to get account: " . $attempts);
    $attempts++;

    $account_query = "SELECT a.id AS account_id FROM account a JOIN user u ON u.account = a.id WHERE u.realname = :realname AND u.email = :email AND u.level=16 LIMIT 1";
    $stmt = $pdo->prepare($account_query);
    $stmt->bindParam(':email', $param_email, PDO::PARAM_INT);
    $stmt->bindParam(':realname', $param_realname, PDO::PARAM_INT);
    $stmt->execute();
    $account_result = $stmt->fetchColumn();

    if ($account_result !== false) {
        break;
    }

    sleep($interval);
}

// Run frraudhosting check if client found
if ($account_result !== false) {
    Info("Execute fraudhosting.check for client ID: " . $account_result);
    shell_exec("sbin/mgrctl -m billmgr fraudhosting.check elid=$account_result su=admin");
} else {
    Error("Not found client with realname: " . $param_realname . ", email: " . $param_email);
}
?>